function Tree() {
    var tempThis = this;

    var defaultId = 0;
    var defaultLimit = 20;
    var defaultCurPage = 0;
    var defaultSearchType = 'contain';
    var defaultOrderSide = 'ASC';
    var defaultSearchString = '';
    var deafultUrlServlet = '/BD/getDbTree?';

    function loadTree(tableName)//, limit, curPage, searchType, orderSide, orderField, where)
    {
        var idTree = '#' + tableName.toUpperCase() + '_TREE';

        var urlServlet = deafultUrlServlet + 'tbn=' + tableName;

        if(defaultId !== 0)
            urlServlet += '&rid=' + defaultId;

        if(defaultLimit !== 20)
            urlServlet += '&lmt=' + defaultLimit;

        if(defaultCurPage !== 0)
            urlServlet += '&cpg=' + defaultCurPage;

        if(defaultSearchString !== '')
            urlServlet += '&srs=' + defaultSearchString;

        //alert(urlServlet);

        $('#TREE_SECTION').load(urlServlet + ' #' + tableName.toUpperCase() + '_TREE_CONTAINER',
                                 function (data, status, xhr)
                                 {
                                     if(status === 'error')
                                     {
                                        var indexInit = data.indexOf('<title>');
                                        var indexFinish = data.indexOf('</title>');
                                        var subErr = data.substring(indexInit + 7, indexFinish);
                                        console.log(data, status, xhr);
                                        alert(subErr);
                                     }

                                     else
                                     {
                                         var result = data.split('<div id="TR_');
                                         result = result[1].split('"');
                                         var id = result[0];

                                         //$('[data-toggle="popover"]').popover();

                                         var idGlyph = '#A_'+ id;
                                         var idEl = '#N_'+ id;

                                         var idClose = '#C_TREE_' + tableName.toUpperCase();
                                         closeTreeOnClick(idClose, tableName);

                                         var itemView = new ItemView();
                                         /*** SPOT BLOCK ***
                                         var spotBlock = itemView.buildSpotSection('tree-spot', 'rgb(255, 255, 255)');

                                         $(spotBlock).insertBefore($('#' + tableName.toUpperCase() + '_TREE_CONTAINER'));
                                         */

                                         activateControllerOnTree(id, tableName);
                                     }

                                 });
    }

    this.loadTree = loadTree;

    function loadChildrenOnTree(tableName, index)
    {
        var idTree = '#' + tableName.toUpperCase() + '_TREE';

        var urlServlet = deafultUrlServlet + 'tbn=' + tableName;

        if(defaultId !== 0)
            urlServlet += '&rid=' + defaultId;

        if(defaultLimit !== 20)
            urlServlet += '&lmt=' + defaultLimit;

        if(defaultCurPage !== 0)
            urlServlet += '&cpg=' + defaultCurPage;

        if(defaultSearchString !== '')
            urlServlet += '&srs=' + defaultSearchString;

        defaultSearchString = '';

        $(index).load(urlServlet + ' ' + index,
                      function (data, status, xhr)
                      {
                          if(status === 'error')
                          {
                             var indexInit = data.indexOf('<title>');
                             var indexFinish = data.indexOf('</title>');
                             var subErr = data.substring(indexInit + 7, indexFinish);
                             console.log(data, status, xhr);
                             alert(subErr);
                          }

                          else
                          {
                              $(index).children('div').appendTo($(index).parent());
                              $(this).remove();
                              //$('[data-toggle="popover"]').popover();

                              for (var temp = 0; temp < $(index).children('div').length; temp++)
                              {
                                  var id = $(index).children().eq(temp).attr('value');
                                  activateControllerOnTree(id, tableName);
                              }
                          }

                          $('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'initial');
                          $('#WAIT').remove();

                      });

    }

    function activateControllerOnTree(id, tableName)
    {
        $('[data-toggle="popover"]').popover();
        var idGlyph = '#A_' + id;
        openChildrenOnClick(idGlyph, tableName);
        activateHoverColoring();
        //activateSearchInTree(tableName);

        var idItem = '#N_' + id;
        openItemViewOnClick(idItem, tableName);
    }
    this.activateControllerOnTree = activateControllerOnTree;

    function openChildrenOnClick(id, tableName)
    {
        $(id).off('click');
        $(id).click(
                    function (e)
                    {
                        e.stopPropagation();

                        if ($(this).hasClass('glyphicon-plus-sign'))
                        {
                            $(this).addClass('selected');
                            $(this).removeClass('glyphicon-plus-sign');
                            $(this).addClass('glyphicon-minus-sign');

                            defaultId = $(this).attr('value');
                            defaultCurPage = 0;
                            var index = '#CH_'+ defaultId;
                            $(this).removeClass('selected');

                            var idParent = $(this).parent().parent().parent().attr('id');
                            idParent = '#'+idParent;
                            var offset = $(idParent).offset().top - 200;
                            $('html, body').animate({scrollTop:offset}, 700);

                            $(index).after("<i id='WAIT' class='glyphicon glyphicon-refresh glyphicon-spin' style='font-size: 80px; font-weight:bold;position:fixed; left:50%; top:50%; dispaly:hidden;'></i>").fadeIn();
                            $('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'none');

                            loadChildrenOnTree(tableName, index);
                        }
                        else
                        {
                             if ($(this).hasClass('glyphicon-minus-sign'))
                             {
                                 index = '#CH_'+ $(this).attr('value');
                                 defaultCurPage = 0;
                                 $(index).empty();
                                 $(this).removeClass('glyphicon-minus-sign');
                                 $(this).addClass('glyphicon-plus-sign');
                             }
                        }


                    });

    }
    this.openChildrenOnClick = openChildrenOnClick;

    function treePagingOnClick(element)
    {
        var pageNumber = $(element).attr('value');
        var actualPage = $(element).attr('curPage');
        if (pageNumber >= 0 && typeof pageNumber !== 'undefined' && pageNumber !== actualPage)
        {
            defaultId  = $(element).attr('rid');
            var tableName = $(element).attr('tbn');

            defaultCurPage = pageNumber;
            var index = '#CH_'+ defaultId;

            $(index).after("<i id='WAIT' class='glyphicon glyphicon-refresh glyphicon-spin' style='font-size: 80px; font-weight:bold;position:fixed; left:50%; top:50%; dispaly:hidden;'></i>").fadeIn();
            $('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'none');

            loadChildrenOnTree(tableName, index);
        }
    }

    this.treePagingOnClick = treePagingOnClick;

    function activateHoverColoring()
    {
        $('.tree_paginate_button').off('hover');
        $('.tree_paginate_button').hover(
                    function ()
                    {
                        $(this).css("background-color",'rgb(43,63,69)');
                    },
                    function()
                    {
                        $(this).css("background-color",'#4c6972');
                    });

    }

    /*

    function activateSearchInTree(element)
    {
        var tableName = $(element).attr('tbn');
        var searchId = '#SEARCH_' + tableName.toUpperCase() + '_TREE';
        defaultSearchString = $(searchId).val();
        //defaultSearchType = $('#' + tableName.toUpperCase() + '_TABLE_SEARCH_TYPE option:selected').attr('value');
        defaultCurPage = 0;
        $(searchId).after("<i id='WAIT' class='glyphicon glyphicon-refresh glyphicon-spin' style='font-size: 80px; font-weight:bold;position:fixed; left:50%; top:50%; dispaly:hidden;'></i>").fadeIn();
        $('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'none');

        defaultId = $(element).attr('rid');
        var index = '#CH_'+ defaultId;

        loadChildrenOnTree(tableName, index);
    }

    this.activateSearchInTree = activateSearchInTree;
    */

    function openItemViewOnClick(id, tableName)
    {
        var itemName = $(id).text();
        var itemId = $(id).attr('value');
        var itemView = new ItemView();
        $(id).off('click');
        $(id).click(
                    function()
                    {
                        $(id).after("<i id='WAIT' class='glyphicon glyphicon-refresh glyphicon-spin' style='font-size: 80px; font-weight:bold;position:fixed; left:50%; top:50%; dispaly:hidden;'></i>").fadeIn();
                        $('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'none');

                        var location = window.location.href.slice(window.location.href.indexOf('?') + 1);
                        if (location !== 'page=view&tab=' + tableName + '&rec=' + itemId)
                        {
                            console.log('location: ', location);
                            history.pushState(null, null, '?page=view&tab=' + tableName + '&rec=' + itemId);
                        }

                        itemView.openItemViewDesc(tableName, itemId);
                    });

    }

    function closeTreeOnClick(id, tableName)
    {
        $(id).off('click');
        $(id).click(
                    function ()
                    {
                        console.log('TREE: ', window.location.href.slice(window.location.href.indexOf('?') + 1));
                        history.pushState(null, null, '?');
                        $('#' + tableName.toUpperCase() + '_TREE_CONTAINER').remove();
                        $('#tree-spot').remove();
                    });

    }
    this.closeTreeOnClick = closeTreeOnClick;

    function openItemViewFromHierarchy(element)
    {
        $('[data-toggle="popover"]').popover('hide');

        //var itemName = $(element).text();
        var itemId = $(element).attr('value');
        var elementId = $(element).attr('id');
        var tableName = $('#TR_' + itemId).attr('name');
        var itemView = new ItemView();

        console.log('itemId: ', itemId, ' elementId: ', elementId, ' tableName: ', tableName);
        $(elementId).after("<i id='WAIT' class='glyphicon glyphicon-refresh glyphicon-spin' style='font-size: 80px; font-weight:bold;position:fixed; left:50%; top:50%; dispaly:hidden;'></i>").fadeIn();
        //$('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'none');

        var location = window.location.href.slice(window.location.href.indexOf('?') + 1);
        if (location !== 'page=view&tab=' + tableName + '&rec=' + itemId)
        {
            console.log('location: ', location);
            history.pushState(null, null, '?page=view&tab=' + tableName + '&rec=' + itemId);
        }

        itemView.openItemViewDesc(tableName, itemId);

    }

    this.openItemViewFromHierarchy = openItemViewFromHierarchy;

    function treePagingOnClickFromHierarchy(element)
    {
        var pageNumber = $(element).attr('value');
        var actualPage = $(element).attr('curPage');
        var treeType = $(element).attr('tree');
        var rid = $(element).attr('rid');
        var itemView = new ItemView();
        if (pageNumber >= 0 && typeof pageNumber !== 'undefined' && pageNumber !== actualPage)
        {
            defaultId  = $(element).attr('rid');
            var tableName = $(element).attr('tbn');

            defaultCurPage = pageNumber;
            var index = '#CH_'+ defaultId;

            $(index).after("<i id='WAIT' class='glyphicon glyphicon-refresh glyphicon-spin' style='font-size: 80px; font-weight:bold;position:fixed; left:50%; top:50%; dispaly:hidden;'></i>").fadeIn();
            //$('#' + tableName.toUpperCase() + '_DIV_TREE_BODY').css('pointer-events', 'none');

            if(treeType === 'ancestors')
                itemView.buildItemViewHierarchyAncestors(tableName, rid, defaultCurPage);

            //else if(treeType === 'successors')
                //itemView.buildItemViewHierarchySuccessors(tableName, rid, defaultCurPage);

            else if(treeType === 'children')
                itemView.buildItemViewHierarchyChildren(tableName, rid, defaultCurPage);
        }
    }

    this.treePagingOnClickFromHierarchy = treePagingOnClickFromHierarchy;

}